#ifndef ReportedError_h
#define ReportedError_h

#ifndef std_string
#define std_string
#include <string>
#endif

using namespace std;

namespace doctorj
{
    class File;

    class ReportedError
    {
    public:
        ReportedError(const string& typ, 
                      const string& msg,
                      File* const f,
                      char* const stPos,
                      int stLn,
                      char* const stFirst,
                      char* const lastPos,
                      int lastLn,
                      char* const startLast);
        
        virtual ~ReportedError();

        string type;

        string message;

        File* file;

        char* startPosition;
        
        int startLine;

        char* startOfFirstLine;
        
        char* lastPosition;
        
        int lastLine;
        
        char* startOfLastLine;

    };
}

#endif //! ReportedError_h
