#ifndef HierarchyTextPrinter_h
#define HierarchyTextPrinter_h

#ifndef HierarchyPrinter_h
#include "HierarchyPrinter.h"
#endif

namespace doctorj
{
    class AstProject;
    class AstNode;
    class AstItem;
    class AstValue;

    class HierarchyTextPrinter : public HierarchyPrinter 
    {
    protected:

        /**
         * Prints a node.
         */
        virtual void print(doctorj::AstNode* const n, int level = 0);
    
        /**
         * Prints an item.
         */
        virtual void print(doctorj::AstItem* const i, int level = 0);

        /**
         * Prints a value.
         */
        virtual void print(doctorj::AstValue* const v, int level = 0);
    
    };
}

#endif //! HierarchyTextPrinter_h
