#ifndef ErrorEmptyIfStatement_h
#define ErrorEmptyIfStatement_h

#ifndef ErrorEmptyStatement_h
#include "ErrorEmptyStatement.h"
#endif

namespace doctorj 
{
    class AstNode;

    class ErrorEmptyIfStatement : public ErrorEmptyStatement 
    {
    public:
        
        ErrorEmptyIfStatement();

        /**
         * Creates the error.
         */
        ErrorEmptyIfStatement(Reporter* const reporter, AstNode* const it);
        
        virtual ~ErrorEmptyIfStatement();

        /**
         * Returns the keyword, "if".
         */
        virtual string keyword() const;

        /**
         * Returns the message describing this error. 
         */
        virtual string message() const;

    };

}

#endif //! ErrorEmptyIfStatement_h
