#ifndef ErrorUselessSuperInMethodInvocation_h
#define ErrorUselessSuperInMethodInvocation_h

#ifndef SyntaxError_h
#include "SyntaxError.h"
#endif

namespace doctorj 
{
    class AstMethodInvocationSuper;
    
    class ErrorUselessSuperInMethodInvocation : public SyntaxError 
    {
    public:
        
        ErrorUselessSuperInMethodInvocation();

        /**
         * Creates the error for the method.
         */
        ErrorUselessSuperInMethodInvocation(Reporter* const reporter, AstMethodInvocationSuper* const mi);

        virtual ~ErrorUselessSuperInMethodInvocation();

        /**
         * Returns the title of this error.
         */
        virtual string title() const;

        /**
         * Writes the long description of this error to the given output stream.
         */
        virtual void writeDescription(ostream& os) const;

        /**
         * Returns the message describing this error. 
         */
        virtual string message() const;

    private:
        /**
         * The name of the method.
         */
        string name_;

    };

}

#endif //! ErrorUselessSuperInMethodInvocation_h
