#ifndef RuleImproperSequence_h
#define RuleImproperSequence_h

#ifndef Rule_h
#include "Rule.h"
#endif

namespace doctorj
{
    class AstClassBodyDeclarationList;
    class AstInterfaceMemberDeclarationList;
    class SequenceChecker;

    class RuleImproperSequence : public Rule
    {
    public:
        RuleImproperSequence(Reporter* const reporter);

        virtual ~RuleImproperSequence();

        virtual void process(AstInterfaceMemberDeclarationList* const im);

        virtual void process(AstClassBodyDeclarationList* const cb);

    protected:
        virtual void compare(AstItem* const previous, AstItem* const current);

    private:
        SequenceChecker* seqChk_;

    };
}

#endif //! RuleImproperSequence_h
