#ifndef RuleRepeatedImportStatement_h
#define RuleRepeatedImportStatement_h

#ifndef Rule_h
#include "Rule.h"
#endif

#ifndef ImportList_h
#include "ImportList.h"
#endif

namespace doctorj
{
    class AstImportDeclaration;

    class RuleRepeatedImportStatement : public Rule
    {
    public:
        RuleRepeatedImportStatement(Reporter* const reporter);

        virtual ~RuleRepeatedImportStatement();

        virtual void process(AstCompilationUnit* const cu);

        virtual void process(AstCompilationUnitEmpty* const cu);

        virtual void process(AstCompilationUnitImp* const cu);

        virtual void process(AstCompilationUnitImpTypes* const cu);

        virtual void process(AstCompilationUnitPkg* const cu);

        virtual void process(AstCompilationUnitPkgImp* const cu);

        virtual void process(AstCompilationUnitPkgImpTypes* const cu);

        virtual void process(AstCompilationUnitPkgTypes* const cu);

        virtual void process(AstCompilationUnitTypes* const cu);

        virtual void process(AstImportDeclaration* const id);

        virtual void process(AstImportDeclarationOnDemand* const id);

        virtual void process(AstImportDeclarationSingle* const id);

    private:
        ImportList imports_;
    };
}

#endif //! RuleRepeatedImportStatement_h
